VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Class_Resolutions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim mCol As Collection

Private Sub Init()
    Set mCol = New Collection
    Dim DevM As DEVMODE
    Dim Res As Class_Resolution

    Dim i As Long:      i = 1
    While EnumDisplaySettings(0&, i&, DevM)
        Set Res = New Class_Resolution
        Res.Bits = DevM.dmBitsPerPel
        Res.Width = DevM.dmPelsWidth
        Res.Height = DevM.dmPelsHeight
        mCol.Add Res
        i = i + 1
    Wend
End Sub

Public Property Get Resolutions() As Collection
    If mCol Is Nothing Then Init
    Set Resolutions = mCol
End Property

Public Function Exists(Width, Height, Bits) As Boolean
    Exists = Not (Resolution(Width, Height, Bits) Is Nothing)
End Function

Public Property Get Resolution(Width, Height, Bits) As Class_Resolution
    Dim Res As Class_Resolution
    For Each Res In Resolutions
        If Res.Width = Width And Res.Height = Height And Res.Bits = Bits Then
            Set Resolution = Res
            Exit Property
        End If
    Next Res
End Property

Public Function SetResolution(new_Width, new_Height, new_Bits) As Boolean
    Dim Res As Class_Resolution
    Set Res = Resolution(new_Width, new_Height, new_Bits)
    If Not Res Is Nothing Then
        SetResolution = True
        Res.Apply
    End If
End Function
